#![feature(string_extend_from_within)]

use boring_argline_pras::{Args, Modes};
use clap::StructOpt;
use comptime::comp;
use runtime::exec;

fn main() {
    match Args::parse() {
        Args {
            // Parse some args
            command: Modes::Run { file },
        } => exec(file),
        Args {
            // Them there args aren't going to parse themselves
            command: Modes::Compile { in_file, out_file },
            // Oh they parsed them there selves
        } => comp(in_file, out_file),
    };
    // I know this is the first thing you read so sorry it's not more spicy "~"
}

mod comptime {
    use std::io::{Seek, Write};

    /// make yourself at home
    pub fn comp(in_file: std::path::PathBuf, out_file: std::path::PathBuf) {
        match std::fs::File::create(out_file) {
            Ok(mut s) => match std::fs::read_to_string(in_file) {
                Ok(bf) => {
                    match s
                        .write(b"fn main() {\n") // hey wait
                        .map(drop) // this was just a main() function
                        .map_err(|e| panic!("Failure in writing file: {e}"))
                    {
                        // where does it set up the tape
                        Ok(()) => (),
                        Err(()) => (),
                    }
                    if let Some(l) = bf.rfind(&['.', ']', '/']) {
                        // Oh clever :o
                        let mut i = 1;
                        for c in bf.chars().take(l + 1) {
                            if let Err(e) = s.write(&b"\t".repeat(i)) {
                                // \t indents probably meaninfless, right?
                                panic!("An unexpected error occurred and the compiler needs to close: {e}")
                                // right?
                            }
                            match match c {
                                // right??
                                '+' => s.write(b"plus();\n"), // if the set up is in all these fns
                                '-' => s.write(b"minus();\n"), // that can't be threadsafe
                                '*' => s.write(b"asterisk();\n"),
                                '/' => s.write(b"slash();\n"),
                                // "\_(🤷‍♀️)_/" Urban muller made some changes ig
                                '<' => s.write(b"less_than();\n"),
                                '>' => s.write(b"greater_than();\n"),
                                ',' => s.write(b"comma();\n"),
                                '.' => s.write(b"period();\n"),
                                '[' => {
                                    i += 1;
                                    s.write(b"for (;loopy();) {\n")
                                    // er, is this... rust?
                                }
                                ']' => {
                                    i -= 1;
                                    s.seek(std::io::SeekFrom::Current(-1))
                                        .and_then(|_| s.write(b"}\n"))
                                }
                                ' ' | '\n' => Ok(0),
                                c => panic!("Character at 4:2:127 non-handled: {c}"), // LIES!
                            } {
                                Ok(_) => (),
                                Err(e) => panic!("Problem writing to the file: {e}"),
                            }
                        }
                    };
                    if let Err(e) = s.write(b"}\n") {
                        panic!("Error: {e}");
                    }
                }
                // This is getting out of hand!
                Err(e) => panic!("Error encountered reading from file: {e}"),
            },
            // Now there are two of them!
            Err(e) => panic!("Could not to write to file: {e}"),
        }
    }
}

// only half of the way through...
// ...
// this is going to be looong :<

mod runtime {
    use futures::executor::block_on;
    use std::{
        cmp::min,
        fs::read_to_string,
        hint::unreachable_unchecked,
        io::{stdin, Read},
        iter::once,
        path::PathBuf,
        str::from_utf8_unchecked,
    };
    use tokio::runtime::*;
    use wgpu::{util::*, *};

    const BYTES: u64 = 30_000 + 4;
    const IO: u64 = 128 * 1024 + 4; // TIO.RUN CANNOT PRINT MORE
                                    // DONT TRY IT

    async fn rt() -> Runtime {
        // Oh my that looks scary, haha
        unsafe { Runtime::new().unwrap_unchecked() }
    }

    pub fn exec(file: PathBuf) {
        let state = unsafe { block_on(init(file)) };
        pollster::block_on(rt())
            .handle()
            .block_on(unsafe { run(state) })
    }

    struct Rantaimu {
        device: Device,
        queue: Queue,
        ouput: Buffer,
        input: Buffer,
        tape: Buffer,
        pipeline: ComputePipeline,
        ijo: BindGroupLayout,
    }

    async unsafe fn init(name: PathBuf) -> Rantaimu {
        let file = read_to_string(name).unwrap_unchecked();
        let instance = Instance::new(Backends::all());
        let adapter = instance
            .request_adapter(&RequestAdapterOptions::default())
            .await
            .unwrap_unchecked();
        let (device, queue) = adapter
            .request_device(
                &DeviceDescriptor {
                    label: None,
                    features: Features::BUFFER_BINDING_ARRAY
                        | Features::STORAGE_RESOURCE_BINDING_ARRAY,
                    limits: Limits::default(),
                },
                None,
            )
            .await
            .unwrap_unchecked(); // At least we don't match on eveery error anymore.
                                 // This is an absolute win.
        let shader = device.create_shader_module(&ShaderModuleDescriptor {
            label: None,
            source: ShaderSource::Wgsl(
                (r#"
struct Tape {
	point: u32;
	tape: array<u32>;
};

struct Spot {
	i: u32;
	o: u32;
};

[[group(0), binding(0)]]
var<storage, read_write> mem: Tape;

[[group(0), binding(1)]]
var<storage, read_write> output: Tape;

[[group(0), binding(2)]]
var<storage, read_write> input: Tape;

fn split(index: u32) -> Spot {
	var nanpa : Spot;
	nanpa.i = index >> 2u;
	nanpa.o = index & 3u;
	return nanpa;
}

fn got() -> u32 {
	let spot = split(mem.point);
	return (mem.tape[spot.i] >> (spot.o * 8u)) & 255u;
}

fn putted(byte: u32) {
	let byte = byte & 255u;
	let spot = split(mem.point);
	let i = spot.i;
	mem.tape[i] = (mem.tape[i] ^ (got() << 8u * spot.o)) | (byte << 8u * spot.o);
}

fn dot_int(byte: u32) {
	let byte = byte & 255u;
	let spot = split(output.point);
	output.point = output.point + 1u;
	output.tape[spot.i] = output.tape[spot.i] | (byte << 8u * spot.o);
}

fn comma_int() -> u32 {
	let spot = split(input.point);
	input.point = input.point + 1u;
	return (input.tape[spot.i] >> (spot.o * 8u)) & 255u;
}

fn plus() {
	putted(got() + 1u);
}
fn minus() {
	putted(got() - 1u);
}
fn asterisk() {
	putted(got() * got());
}

fn slash() {
	dot_int(got() / 100u + 48u);
	dot_int((got() / 10u) % 10u + 48u);
	dot_int(got() % 10u + 48u);
}

fn less_than() {
	mem.point = mem.point - 1u;
}
fn greater_than() {
	mem.point = mem.point + 1u;
}
fn period() { // dot is a reserved word
	dot_int(got());
}
fn comma() {
	putted(comma_int());
}

fn loopy() -> bool {
	return bool(got());
}

[[stage(compute), workgroup_size(0)]]
"# // AH! scared the shit out of me. My poor heart can only take small string lits
                .to_owned()
                    + &file) // say what you want about rustfmt, it tells some great jokes
                    .into(),
            ),
        });
        // don't tell me these are just for putting data in
        let tap = device.create_buffer(&BufferDescriptor {
            label: Some("output buffer"),
            size: BYTES,
            usage: BufferUsages::all(),
            mapped_at_creation: false,
        });
        let outpt = device.create_buffer(&BufferDescriptor {
            label: Some("io"),
            size: IO,
            usage: BufferUsages::all(),
            mapped_at_creation: false,
        });
        let input = device.create_buffer(&BufferDescriptor {
            label: Some("i"),
            size: IO,
            usage: BufferUsages::all(),
            mapped_at_creation: false,
        });
        // man here we go, bind group layouts!
        let ijo = device.create_bind_group_layout(&BindGroupLayoutDescriptor {
            label: None,
            entries: &[
                BindGroupLayoutEntry {
                    binding: 0,
                    visibility: ShaderStages::COMPUTE,
                    ty: BindingType::Buffer {
                        ty: BufferBindingType::Storage { read_only: false },
                        has_dynamic_offset: false,
                        min_binding_size: Some(8.try_into().unwrap_unchecked()),
                    },
                    count: None,
                },
                BindGroupLayoutEntry {
                    binding: 1,
                    visibility: ShaderStages::COMPUTE,
                    ty: BindingType::Buffer {
                        ty: BufferBindingType::Storage { read_only: false },
                        has_dynamic_offset: false,
                        min_binding_size: Some(8.try_into().unwrap_unchecked()),
                    },
                    count: None,
                },
                BindGroupLayoutEntry {
                    binding: 2,
                    visibility: ShaderStages::COMPUTE,
                    ty: BindingType::Buffer {
                        ty: BufferBindingType::Storage { read_only: false },
                        has_dynamic_offset: false,
                        min_binding_size: Some(8.try_into().unwrap_unchecked()),
                    },
                    count: None,
                },
            ],
        });
        // Now I have peeled off my mask and you can see, that I am jan Nowe. I! >:D
        let pipeline_layout = device.create_pipeline_layout(&PipelineLayoutDescriptor {
            label: None,
            bind_group_layouts: &[&ijo],
            push_constant_ranges: &[],
        });
        // beware of the pipeline
        let pipeline = device.create_compute_pipeline(&ComputePipelineDescriptor {
            label: Some("computpipette"),
            layout: Some(&pipeline_layout),
            module: &shader,
            entry_point: "main",
        });
        Rantaimu {
            device,
            queue,
            ouput: outpt,
            input,
            tape: tap,
            pipeline,
            ijo,
        }
    }

    async unsafe fn run(state: Rantaimu) {
        let stdin = stdin();
        let mut input = "\x00\x00\x00\x00".to_string();
        let mut input_length = stdin.lock().read_to_string(&mut input).unwrap_unchecked();
        while input_length % 4 > 0 {
            input_length += 3;
            input.extend_from_within(..3)
        }
        // this looks boilerplate to me
        let exit = state.device.create_buffer(&BufferDescriptor {
            label: Some("exit"),
            size: BYTES,
            usage: BufferUsages::all(),
            mapped_at_creation: false,
        });
        let entry = state.device.create_buffer_init(&BufferInitDescriptor {
            label: Some("entry"),
            contents: input.as_bytes(),
            usage: BufferUsages::all(),
        });
        // So you think you can stop me.
        // I dont even care any more. Do your worst.
        let bind_group = state.device.create_bind_group(&BindGroupDescriptor {
            label: Some("bingroup for binding The Group"),
            layout: &state.ijo,
            entries: &[
                BindGroupEntry {
                    binding: 0,
                    resource: state.tape.as_entire_binding(),
                },
                BindGroupEntry {
                    binding: 1,
                    resource: state.ouput.as_entire_binding(),
                },
                BindGroupEntry {
                    binding: 2,
                    resource: state.input.as_entire_binding(),
                },
            ],
        });
        let mut encoder = state
            .device
            .create_command_encoder(&CommandEncoderDescriptor::default());

        // Nani
        encoder.copy_buffer_to_buffer(&entry, 0, &state.input, 0, min(IO, input_length as u64 + 4));
        // what is going on
        let mut compute = encoder.begin_compute_pass(&ComputePassDescriptor::default());
        compute.set_pipeline(&state.pipeline);
        compute.set_bind_group(0, &bind_group, &[]);
        compute.dispatch(1, 1, 1);
        drop(compute); // this code belongs down the toilet
        encoder.copy_buffer_to_buffer(&state.ouput, 0, &exit, 0, BYTES);

        // println!("submitting commands");
        state.queue.submit(once(encoder.finish()));
        // println!("submitted commands");

        let slice_soon = exit.slice(..);
        let soon = slice_soon.map_async(MapMode::Read);
        state.device.poll(Maintain::Wait);

        if let Ok(()) = soon.await {
            let slice_now_yes = slice_soon.get_mapped_range();
            let data: Vec<_> = slice_now_yes.iter().collect();
            // like look at this shit
            let start = *data[0] as u32
                | (*data[1] as u32) << (1 * 8)
                | (*data[2] as u32) << (2 * 8)
                | (*data[3] as u32) << (3 * 8);
            // this is what rust users put up with
            let words: Vec<_> = data[4..start as usize + 4].iter().map(|&&x| x).collect();
            // why is it so hard just to read some bytes
            print!("{}", from_utf8_unchecked(&words));
        } else {
            let _: VertexState = None.expect("brok brok brok"); // I swear its like I don't know how to spell
            unreachable_unchecked() // cute
        }
    }
    // oh hej, we're done
}

// aa

// aaa

///aaaa

#[rustfmt::skip]mod boring_argline_pras{use clap::*;use std::path::*;#[derive(Parser)]pub struct Args{#[clap(subcommand)]pub command:Modes}#[derive(Subcommand)]pub enum Modes{#[clap(name="-r")]Run{file:PathBuf},#[clap(name="-c")]Compile{in_file:PathBuf,out_file:PathBuf}}}

// gesundheit
